package com.nd.idaas.demo.config;

import com.nd.gaea.rest.config.WafWebSecurityConfigurerAdapter;
import com.nd.gaea.rest.exceptions.DefaultWafRestErrorResolver;
import com.nd.gaea.rest.exceptions.WafErrorResolver;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.security.config.annotation.web.builders.HttpSecurity;
import org.springframework.security.config.annotation.web.servlet.configuration.EnableWebMvcSecurity;

/**
 * 安全认证扩展类
 *
 * @author vime
 * @since 0.9.5
 */
@Configuration
@EnableWebMvcSecurity
public class ApiSecurityConfig extends WafWebSecurityConfigurerAdapter {
    /**
     * 此处统一配置安全访问控制
     *
     * @param http
     * @throws Exception
     */
    @Override
    protected void onConfigure(HttpSecurity http) throws Exception {}

    /**
     * demo:重写此方法，设置忽略路径
     */
    /*
     * @Override public void configure(WebSecurity web) throws Exception { //忽略请求为/students/**的所有PUT方法的安全认证
     * //web.ignoring().antMatchers(HttpMethod.PUT, "/students/**"); }
     */

    /**
     * 不使用mactoken的缓存类
     * @return
     */
    /*
     * @Bean(name = {"mac_token_service"})
     * 
     * @Primary public TokenService userCenterMacTokenService(){ return new UserCenterMacTokenService(); }
     */

    /**
     * 在缓存类基础上开启nonce校验
     * @return
     */
    /*
     * @Bean(name = {"mac_token_service"})
     * 
     * @Primary public TokenService userCenterMacTokenService(){ return new UserCenterMacTokenCacheService(); }
     */

    /**
     * demo:设置传递Userid
     * @return
     */
    /*
     * @Bean
     * 
     * @Primary public BearerAuthorizationProvider bearerAuthorizationProvider() { return new
     * DeliverBearerAuthorizationProvider(); }
     */

    /**
     * demo:注册自定义异常处理类
     *
     * @return
     */
    @Bean
    public WafErrorResolver myDefaultWafRestErrorResolver() {
        return new DefaultWafRestErrorResolver();
    }

    /**
     * demo:注册自定义的MAC token开关实现类
     * @return
     */
    /*
     * @Bean
     *
     * @Primary public MacTokenService MacTokenService(){ return new MacTokenServiceImpl(); }
     */

    /**
     * demo:初始化游客模式白名单配置类
     * @return
     */
    /*
     * @Bean public VistorsService vistorsService() { return new VistorsServiceImpl(); }
     */

    /**
     * 注册自定义游客模式扩展类
     * @return
     */
    /*
     * @Bean public VisitorsAdapter visitorsAdapter(){ return new MyVisitorsAdapter(); }
     */
}
